###[DEF]###
[name		=	Warmwasser					]

[e#1 TRIGGER=	A: Dauerladung  #init=0		] 
[e#2		=	A: Soll-Temperatur  #init=35]
[e#3		=	A: Offset  #init=3			]
[e#4 TRIGGER=	B: Einmalladung #init=0		]
[e#5		=	B: Soll-Temperatur #init=35	]
[e#6		=	B: Offset #init=3			]
[e#7 TRIGGER=	C: Einmalladung #init=0		]
[e#8		=	C: Soll-Temperatur #init=45	]
[e#9		=	C: Offset #init=3			]
[e#10 TRIGGER=	Ist-Temperatur				]

[a#1		=	A: Status		]
[a#2		=	B: Status		]
[a#3		=	C: Status		]
[a#4		=	A: Warm			]
[a#5		=	B: Warm			]
[a#6		=	C: Warm			]
[a#7		=	Heizen 			]

[v#1		=0				] 1=A aktiviert
[v#2		=0				] 1=B aktiviert
[v#3		=0				] 1=C aktiviert
###[/DEF]###


###[HELP]###
Der Baustein wird lediglich durch die Ist-Temperatur (und die Eingänge E1/E4/E7) getriggert. Eine Änderung z.B. der Solltemperatur wird erst beim nächsten Triggern berücksichtigt, also z.B. wenn die Ist-Temperatur sich geändert hat oder E1/E4/E7 aktualisiert wurden.

Verhalten:
<ul>
	<li>die neue Aktivierung einer Einmalladung B/C (E4=1 oder E7=1) übersteuert eine evtl. aktivierte Dauerladung A</li>
	<li>nach Beendigung der Einmalladung (manuell oder bei Erfolg) führt ggf. wieder zu einer aktiven Dauerladung (falls diese aktiviert wurde)</li>
	<li>
		die Einmalladungen toggeln sich gegenseitig:
		<ul>
			<li>läuft also z.B. B und wird dann C aktiviert, wird B automatisch und dauerhaft deaktiviert</li>
			<li>nach Beendigung von C ist dann keine der beiden Einmalladungen B/C mehr aktiv!</li>
			<li>die Dauerladung A bleibt davon unberührt und wird ggf. dann wieder aktiviert</li>
		</ul>
	</li>
</ul>

Beim Erreichen der Soll-Temperatur (E2/E5/E8) wird der Heizvorgang für den jeweiligen Modus A/B/C beendet. 
Der Offset (E3/E6/E9) definiert einen Toleranzbereich (Hysterese), d.h. der Heizvorgang wird nur dann aktiviert, wenn die Ist-Temperatur (E10) unterhalb der Soll-Temperatur abzüglich des Offsets liegt. 

E1: Dauerladung A (1=Ein, 0=Aus)
E2: Soll-Temperatur 
E3: Offset (s.o.)

E4: Einmalladung B (1=Starten, 0=Abbruch): ein neues(!) Telegramm =1 triggert die Einmalladung, diese kann mit 0 abgebrochen werden
E5: Soll-Temperatur 
E6: Offset (s.o.)

E7: Einmalladung C (1=Starten, 0=Abbruch): ein neues(!) Telegramm =1 triggert die Einmalladung, diese kann mit 0 abgebrochen werden
E8: Soll-Temperatur
E9: Offset (s.o.)

E10: Ist-Temperatur: die aktuelle Wassertemperatur


A1: Status: Dauerladung A ist gerade aktiv (1/0)
A2: Status: Einmalladung B ist gerade aktiv (1/0)
A3: Status: Einmalladung C ist gerade aktiv (1/0)
A4: Dauerladung A: 0=Wasser ist "kalt", 1=Wasser ist warm (also im Toleranzbereich)
A5: Einmalladung B: 0=Wasser ist "kalt", 1=Wasser ist warm (also im Toleranzbereich)
A6: Einmalladung C: 0=Wasser ist "kalt", 1=Wasser ist warm (also im Toleranzbereich)
A7: Heizen (0/1): mit diesem Ausgang kann ein entsprechender Boiler direkt angesteuert werden

<b>Hinweis:</b>
Alle Ausgänge werden nicht(!) nur bei einer Änderung gesetzt, ggf. ist also mit einem Send-By-Change-Baustein zu arbeiten.
###[/HELP]###


###[LBS]###
<?
function LB_LBSID($id) {
	if ($E=logic_getInputs($id)) {

		$refresh=false;

		//Einmalladung B
		//-----------------------------------
		if ($E[4]['refresh']==1) { 			
			$refresh=true;
			if ($E[4]['value']!=0) {											//Aktivieren
				if ($E[10]['value']<=($E[5]['value']-$E[6]['value'])) {			//Einschalttemperatur erreicht
					logic_setVar($id,2,1);		//Einmalladung B aktiviert
					logic_setVar($id,3,0);		//Einmalladung C deaktiviert
					logic_setOutput($id,1,0); 	//Status Dauerladung A Aus
					logic_setOutput($id,2,1); 	//Status Einmalladung B Ein
					logic_setOutput($id,3,0); 	//Status Einmalladung C Aus
					logic_setOutput($id,7,1); 	//Boiler Ein
				} else {														//Ausschalttemperatur erreicht
					logic_setVar($id,2,0);		//Einmalladung B deaktiviert
					logic_setVar($id,3,0);		//Einmalladung C deaktiviert
					logic_setOutput($id,2,0); 	//Status Einmalladung B Aus
					logic_setOutput($id,3,0); 	//Status Einmalladung C Aus
					logic_setOutput($id,7,0); 	//Boiler Aus
				}
			} else {															//Deaktivieren
				logic_setVar($id,2,0);			//Einmalladung B deaktiviert
				logic_setVar($id,3,0);			//Einmalladung C deaktiviert
				logic_setOutput($id,2,0); 		//Status Einmalladung B Aus
				logic_setOutput($id,3,0); 		//Status Einmalladung C Aus
				logic_setOutput($id,7,0); 		//Boiler Aus
			}
		}

		//Einmalladung C
		//-----------------------------------
		if ($E[7]['refresh']==1) { 			
			$refresh=true;
			if ($E[7]['value']!=0) {											//Aktivieren
				if ($E[10]['value']<=($E[8]['value']-$E[9]['value'])) {			//Einschalttemperatur erreicht
					logic_setVar($id,2,0);		//Einmalladung B deaktiviert
					logic_setVar($id,3,1);		//Einmalladung C aktiviert
					logic_setOutput($id,2,0); 	//Status Einmalladung B Aus
					logic_setOutput($id,3,1); 	//Status Einmalladung C Ein
					logic_setOutput($id,7,1); 	//Boiler Ein
				} else {														//Ausschalttemperatur erreicht
					logic_setVar($id,2,0);		//Einmalladung B deaktiviert
					logic_setVar($id,3,0);		//Einmalladung C deaktiviert
					logic_setOutput($id,1,0); 	//Status Dauerladung A Aus
					logic_setOutput($id,2,0); 	//Status Einmalladung B Aus
					logic_setOutput($id,3,0); 	//Status Einmalladung C Aus
					logic_setOutput($id,7,0); 	//Boiler Aus
				}
			} else {															//Deaktivieren
				logic_setVar($id,2,0);			//Einmalladung B deaktiviert
				logic_setVar($id,3,0);			//Einmalladung C deaktiviert
				logic_setOutput($id,2,0); 		//Status Einmalladung B Aus
				logic_setOutput($id,3,0); 		//Status Einmalladung C Aus
				logic_setOutput($id,7,0); 		//Boiler Aus
			}
		}
				
		//Dauerladung A
		//-----------------------------------
		if ($E[1]['refresh']==1) { 	
			$refresh=true;
			if ($E[1]['value']!=0) {											//Aktivieren
				logic_setVar($id,1,1);			//Dauerladung A aktiviert
				if ($E[10]['value']<=($E[2]['value']-$E[3]['value'])) {			//Einschalttemperatur erreicht
					logic_setOutput($id,1,1); 	//Status Dauerladung Ein
					logic_setOutput($id,7,1); 	//Boiler Ein
				} else {														//Ausschalttemperatur erreicht
					logic_setVar($id,2,0);		//Einmalladung B deaktiviert
					logic_setVar($id,3,0);		//Einmalladung C deaktiviert
					logic_setOutput($id,1,0); 	//Status Dauerladung A Aus
					logic_setOutput($id,2,0); 	//Status Einmalladung B Aus
					logic_setOutput($id,3,0); 	//Status Einmalladung C Aus
					logic_setOutput($id,7,0); 	//Boiler Aus
				}
			} else {															//Deaktivieren
				logic_setVar($id,1,0);			//Dauerladung A deaktiviert
				logic_setOutput($id,1,0); 		//Status Dauerladung Aus
				logic_setOutput($id,7,0); 		//Boiler Aus
			
			}			
		}


		//Ist-Temperatur-Änderung triggert die Überwachung (bzw. ein Refresh von E1/E4/E7)
		//-----------------------------------
		if ($E[10]['refresh']==1 || $refresh) {
			//Temperatur-Check für A4/A5/A6
			if ($E[10]['value']>($E[2]['value']-$E[3]['value'])) {logic_setOutput($id,4,1);} else {logic_setOutput($id,4,0);}
			if ($E[10]['value']>($E[5]['value']-$E[6]['value'])) {logic_setOutput($id,5,1);} else {logic_setOutput($id,5,0);}
			if ($E[10]['value']>($E[8]['value']-$E[9]['value'])) {logic_setOutput($id,6,1);} else {logic_setOutput($id,6,0);}

			//Solltemperatur erreicht, bzw. bei Dauerladung zusätzlich: Einschalttemperatur erreicht?
			if (logic_getVar($id,2)==1) {				//Einmalladung B aktiv?
				if ($E[10]['value']>=$E[5]['value']) {	//Solltemperatur erreicht?
					logic_setVar($id,2,0);		//Einmalladung B aus
					logic_setOutput($id,2,0); 	//Status Einmalladung B Aus
					logic_setOutput($id,7,0); 	//Boiler Aus
				}
			} else if (logic_getVar($id,3)==1) {		//Einmalladung C aktiv?
				if ($E[10]['value']>=$E[8]['value']) {	//Solltemperatur erreicht?
					logic_setVar($id,3,0);		//Einmalladung C aus
					logic_setOutput($id,3,0); 	//Status Einmalladung C Aus
					logic_setOutput($id,7,0); 	//Boiler Aus
				}
			} else if (logic_getVar($id,1)==1) {		//Dauerladung A aktiv?
				if ($E[10]['value']>=$E[2]['value']) {	//Solltemperatur erreicht?
					logic_setOutput($id,1,0); 	//Status Dauerladung A Aus
					logic_setOutput($id,7,0); 	//Boiler Aus
				} else if ($E[10]['value']<=($E[2]['value']-$E[3]['value'])) {	//Einschalttemperatur erreicht?
					logic_setOutput($id,1,1); 	//Status Dauerladung A Ein
					logic_setOutput($id,7,1); 	//Boiler Ein
				}
			}
		}

	}
}
?>
###[/LBS]###


###[EXEC]###
<?
?>
###[/EXEC]###