###[DEF]###
[name		=Alarmtrigger (Pause)	]

[e#1 TRIGGER=Trigger				]
[e#2		=Pause					]
[e#3		=Dauer (s)#init=30]
[e#4		=Aktiviert/Reset			]

[a#1		=Alarm			 		]
[a#2		=Pause		 			]

[v#1		=0						] (Pausentimer)
###[/DEF]###


###[HELP]###
Ein Signal &ne;0 an E1 triggert einen Alarm an A1. Dies kann jedoch temporär unterdrückt werden, wenn an E2 ein Signal &ne;0 anliegt. Dann wird für die Pausendauer (E3) jedes Signal an E1 ignoriert.
Jeder Alarm setzt A1 erneut auf 1. Der Ausgang A1 wird erst bei einem Signal an E4 wieder auf 0 gesetzt.
Am Ausgang A2 liegt eine 1 an, wenn gerade eine Pause aktiv ist (z.B. zur Signalisierung per LED). Ist die Pause beendet, wird A2 wieder auf 0 gesetzt.

Typischer Anwendungsfall:
Reed-Kontakte an E1, BWMs im entsprechenden Raum an E2. Die BWMs pausieren dann den Baustein beim Öffnen eines Fensters von innen(!). Beim Öffnen von außen sprechen die BWMs hingegen nicht an (sind ja im innern des Hauses) und der Alarm wird ausgelöst.

E1: Signal 0/&ne;0: Ein Telegramm &ne;0 triggert den Alarm, falls der Baustein aktiv ist und nicht gerade pausiert
E2: Pause 0/&ne;0: Ein Telgramm &ne;0 pausiert den Baustein
E3: Dauer der Pausierung in Sekunden
E4: 0=Deaktiviert, 1=Aktiviert/Reset: wird im Normalfall mit dem Ausgang "Aktiv" der Alarmanlage verbunden. Bei JEDEM Telegramm wird der Alarm zurückgesetzt und eine Pause ggf. abgebrochen.

A1: Alarmausgang 0/1: Wird bei Alarm auf 1 gesetzt (und wird erst beim nächsten Deaktivieren/Reset wieder auf 0 gesetzt). Jeder Alarm setzt A1 erneut auf 1, so dass ein nachfolgender Alarmtrigger-Eingang erneut getriggert wird.
A2: Pause 0/1: bei einer Pause wird A2 auf 1 gesetzt, ist die Pause vorbei auf 0 (oder bei Alarm bzw. Deaktivierung/Reset). Praktisch um z.B. eine LED anzusteuern, die eine Pause signalisieren soll.
###[/HELP]###


###[LBS]###
<?
function LB_LBSID($id) {

	if ($E=logic_getInputs($id)) {

		if ($E[4]['refresh']==1 && $E[4]['value']==1) { //BS wurde aktiviert oder resettet

			if ($E[2]['value']!=0) {	//Pause während des aktivierens schon aktiv?
				logic_setOutput($id,1,0);
				logic_setOutput($id,2,1); //Pause
				logic_setVar($id,1,(getMicrotime()+$E[3]['value']));
				logic_setState($id,1,$E[3]['value']*1000);
			} else {
				logic_setOutput($id,1,0);
				logic_setOutput($id,2,0);
				logic_setVar($id,1,0);
				logic_setState($id,0);
			}

		} else if ($E[4]['refresh']==1 && $E[4]['value']==0) { //BS wurde deaktiviert

			logic_setOutput($id,1,0);
			logic_setOutput($id,2,0);
			logic_setVar($id,1,0);
			logic_setState($id,0);

		}


		if ($E[4]['value']==1) { //Aktiviert?

			//Pause?
			if ($E[2]['value']!=0 && $E[2]['refresh']==1) {
				logic_setOutput($id,2,1); //Pause
				logic_setVar($id,1,(getMicrotime()+$E[3]['value']));
				logic_setState($id,1,$E[3]['value']*1000);
			}

			if (logic_getState($id)==1) {
				//Pausenzeit abgelaufen?
				if (getMicrotime()>=logic_getVar($id,1)) {
					logic_setOutput($id,2,0); //Pause beendet
					logic_setVar($id,1,0);
					logic_setState($id,0);
				}
			} else {
				//Alarm?
				if ($E[1]['value']!=0 && $E[1]['refresh']==1) {
					logic_setOutput($id,1,1); //Alarm!
					logic_setOutput($id,2,0); //Pause beendet
					logic_setVar($id,1,0);
					logic_setState($id,0);
				}
			}

		}

	}
}
?>
###[/LBS]###


###[EXEC]###
<?

?>
###[/EXEC]###