###[DEF]###
[name		=Alarmanlage			]

[e#1 TRIGGER=A: Alarm		] (Abwesend 1, z.B. mit BWMs)
[e#2 TRIGGER=B: Alarm		] (Abwesend 2, z.B. ohne BWMs)
[e#3 TRIGGER=C: Alarm		] (Anwesend)
[e#4 TRIGGER=D: Alarm		] (Panik)
[e#5		=A: Aktiviert 		#init=0				]
[e#6		=B: Aktiviert	 	#init=0				]
[e#7		=C: Aktiviert 	  	#init=1				] (Anwesend, per default aktiviert)
[e#8		=D: Aktiviert 	   	#init=1				] (Panikalarm, per default aktiviert)
[e#9 TRIGGER=A/B/C/D: Quittierung					] (für 1+2+3)
[e#10 OPTION=A/B/C: Scharfverzögerung (s)#init=30	] (nur für 1+2+3)
[e#11 OPTION=C: Voralarmdauer (s)#init=10			] (nur für 3)
[e#12 OPTION=A/B/C: Alarmdauer (m)	#init=30		] (für 1..3)

[a#1		=A: Alarm		 		] (Alarm)
[a#2		=B: Alarm	 			]
[a#3		=C: Alarm	 			]
[a#4		=D: Alarm	 			]
[a#5		=A: Aktiviert		 		] (Ein/Aus)
[a#6		=B: Aktiviert		 		] (Ein/Aus)
[a#7		=C: Aktiviert		 		] (Ein/Aus)
[a#8		=D: Aktiviert		 		] (Ein/Aus)
[a#9		=A: Scharf			 		] (scharf/unscharf)
[a#10		=B: Scharf	 				]
[a#11		=C: Scharf	 				]
[a#12		=D: Scharf	 				]
[a#13		=C: Voralarm	 			] (nur für 3)

[v#1		=0						] (Alarmanlagenmodus 1/2/3)
[v#2		=0						] (Alarmtimer 1/2/3)
[v#3		=0						] (Voralarmtimer 3)
[v#4		=0						] (Scharfschalttimer 1/2/3)
[v#5		=0						] (scharf 1/2/3)
[v#6		=0						] (Alarm 1/2/3)
###[/DEF]###


###[HELP]###
Dieser Baustein verwaltet 4 Alarmanlagen:
<ul>
<li>Alarmanlage A: Abwesend, z.B. mit Bewegungsmeldern</li>
<li>Alarmanlage B: Abwesend, z.B. ohne Bewegungsmelder (Haustier verbleibt im Haus)</li>
<li>Alarmanlage C: Anwesend</li>
<li>Alarmanlage D: Panik</li>
</ul>

Die Alarmanlage D (Panikalarm) funktioniert vollkommen unabhängig von den anderen Alarmanlagen.

Alarmanlage A und B können nur alternierend aktiviert werden, d.h. es kann nur Alarmanlage A ODER B tatsächlich aktiv sein.

Alarmanlage C kann nur dann tatsächlich aktiviert sein, wenn Alarmanlage A und B deaktiviert sind. Die Alarmanlage C wird dabei automatisch deaktivert, sobald Alarmanlage A oder B aktiviert werden. Werden Alarmanlage A oder B wieder deaktiviert, wird Alarmanlage C ggf. wieder automatisch aktiviert.

<ul>
<li>wird Alarmanlage A (E5) aktiviert, werden Alarmanlage B und C deaktiviert.</li>
<li>wird Alarmanlage A (E5) deaktiviert, wird Alarmanlage C ggf. wieder aktiviert (sofern E7=1 ist).</li>
<li>wird Alarmanlage B (E6) aktiviert, werden Alarmanlage A und C deaktiviert.</li>
<li>wird Alarmanlage B (E6) deaktiviert, wird Alarmanlage C ggf. wieder aktiviert (sofern E7=1 ist).</li>
<li>Alarmanlage C (E7) kann nur dann aktiviert werden, wenn Alarmanlage A und B deaktiviert sind.</li>
<li>Alarmanlage D (E8) ist zu jeder Zeit vollkommen unabhängig von Alarmanlage A/B/C. Auch die Alarmierung (A4) kann zusätzlich(!) zu einer Alarmierung der anderen Alarmanlage erfolgen! Ein Alarm wird NICHT automatisch nach Ablauf der Alarmdauer beendet!</li>
</ul>

Hinweise:
<ul>
<li>Unabhängig von den Werten an E5..E7 (nicht E8!) wird immer nur EINE der Alarmanlagen aktiviert, dabei haben die Alarmanlagen A und B immer Vorrang gegenüber Alarmanlage C.</li>
<li>ACHTUNG: Eine Scharfschalt-Verzögerung ist dringend anzuraten, da sonst bei einem Server-Neustart und z.B. einem bereits geöffneten Fenster ein Alarm ausgelöst werden könnte (das Fenster triggert nach einem Neustart und die Alarmanlage ist u.U. bereits scharf).</li>
</ul>

<hr>

Eingänge:
<ul>
<li>E1: Trigger 0/1: ein NEUES Telegramm =1 NACH der Scharfschaltung löst Alarmanlage A aus</li>
<li>E2: Trigger 0/1: ein NEUES Telegramm =1 NACH der Scharfschaltung löst Alarmanlage B aus</li>
<li>E3: Trigger 0/1: ein NEUES Telegramm =1 NACH der Scharfschaltung löst Alarmanlage C aus</li>
<li>E4: Trigger 0/1: ein NEUES Telegramm =1 NACH der Scharfschaltung löst Alarmanlage D aus</li>
<li>E5..E8: Aktiviert 0/1: Aktiviert/Deaktiviert die entsprechende Alarmanlage A/B/C/D. Soll der Zustand nach einem Neustart erhalten bleiben, müssen die entsprechenden KOs remanent sein.</li>
<li>E9: Quittierung 0/1: Ein Telegramm =1 quittiert/beendet einen Alarm (A/B/C/D), der Zustand vor dem Alarm wird exakt wieder hergestellt (die Alarmanlage(n) bleiben scharf, etc.)</li>
<li>E10: Scharfschaltverzögerung in Sekunden (nur für Alarmanlagen A/B/C): Nach Aktivierung einer Alarmanlage A/B/C wird die Scharfschaltung um diese Zeit verzögert. ACHTUNG: Eine Verzögerung ist dringend anzuraten, da sonst bei einem Server-Neustart und z.B. einem bereits geöffneten Fenster ein Alarm ausgelöst werden würde.</li>
<li>E11: Voralarmdauer in Sekunden (nur für Alarmanlage C): Vor dem Alarm (A3) wird für die eingestellte Dauer ein Voralarm (A13) aktiviert. Sobald der Voralarm beendet ist (und bis dahin keine Quittierung/Deaktivierung erfolgt ist), wird der richtige Alarm (A3) aktiviert.</li>
<li>E12: Alarmdauer in Minuten(!) (nur für Alarmanlagen A/B/C): Nach dieser Zeit werden die Alarmausgänge (A1..A3) auf 0 gesetzt, der Zustand vor dem Alarm wird exakt wieder hergestellt (die Alarmanlage(n) bleiben scharf, etc.). Entspricht quasi der Quittierung, jedoch nur für Alarmanlage A/B/C (NICHT für D!). Der Alarm der Alarmanlage D (Panikalarm) ist zeitlich unbegrenzt!</li>
</ul>

Ausgänge:
<ul>
<li>A1..A4: Alarm ausgelöst 0/1: Im Alarmfall liegt eine 1 an. Nach Quittierung oder Deaktivierung der entsprechenden Alarmanlage wird der entsprechende Ausgang wieder auf 0 gesetzt.</li>
<li>A5..A8: Alarmanlage aktiviert 0/1: Ist die entsprechende Alarmanlage tatsächlich(!) aktiviert, wird der entsprechende Ausgang auf 1 gesetzt (sonst auf 0). Die tatsächliche Aktivierung kann von den Zuständen an E5..E8 abweichen!</li>
<li>A9..A12: Alarmanlage scharf/unscharf 0/1: Ist die entsprechende Alarmanlage scharf, liegt eine 1 an (sonst 0). Bei Alarmanlage A/B/C kann die Scharfschaltung verzögert erfolgen - je nach Wert an E10.</li>
<li>A13: Voralarm 0/1: Betrifft nur Alarmanlage C! Der Ausgang wird im Alarmfall für die Zeit an E11 auf 1 gesetzt. Nach Ablauf der Zeit wird der Ausgang auf 0 gesetzt und der Alarmausgang A3 wird aktiviert.</li>
</ul>
###[/HELP]###


###[LBS]###
<?
function LB_LBSID($id) {

	if (($E=logic_getInputs($id)) && ($V=logic_getVars($id))) {

		$modus=$V[1];
		$alarm=$V[6];

		//Abwesend 1
		if ($E[5]['refresh']==1) {
			if ($E[5]['value']==1) {
				if ($modus==0 || $modus==3) {
					$modus=LB_LBSID_setAlarmMode($id,$E,1);		//Alarm 1 aktivieren
				}
			} else if ($modus==1) {
				$modus=LB_LBSID_setAlarmMode($id,$E,0); 		//Alarm 1/2/3 deaktivieren
				if ($E[7]['value']==1) {
					$modus=LB_LBSID_setAlarmMode($id,$E,3); 	//ggf. Alarm 3 aktivieren
				}
			}
		}
		//Abwesend 2
		if ($E[6]['refresh']==1) {
			if ($E[6]['value']==1) {
				if ($modus==0 || $modus==3) {
					$modus=LB_LBSID_setAlarmMode($id,$E,2);		//Alarm 2 aktivieren
				}
			} else if ($modus==2) {
				$modus=LB_LBSID_setAlarmMode($id,$E,0); 		//Alarm 1/2/3 deaktivieren
				if ($E[7]['value']==1) {
					$modus=LB_LBSID_setAlarmMode($id,$E,3); 	//ggf. Alarm 3 aktivieren
				}
			}
		}
		//Anwesend
		if ($E[7]['refresh']==1) {
			if ($E[7]['value']==1) {
				if ($modus==0) {
					$modus=LB_LBSID_setAlarmMode($id,$E,3);		//Alarm 3 aktivieren
				}
			} else if ($modus==3) {
				$modus=LB_LBSID_setAlarmMode($id,$E,0); 		//Alarm 1/2/3 deaktivieren
			}
		}

		//Panikalarm (unabhängig vom Rest)
		if ($E[8]['refresh']==1) {
			if ($E[8]['value']==1) {
				//Panikalarm aktivieren
				logic_setOutput($id,8,1);					//Alarm 4 = Ein
				logic_setOutput($id,12,1); 					//scharf
			} else {
				//Panikalarm deaktivieren
				logic_setOutput($id,8,0);					//Alarm 4 = Aus
				logic_setOutput($id,12,0); 					//unscharf
				logic_setOutput($id,4,0); 					//Alarm! aus
			}
		}

		//Panikalarm-Trigger? (kann immer ausgelöst werden)
		if ($E[8]['value']==1) {
			if ($E[4]['value']==1 && $E[4]['refresh']==1) {
				logic_setOutput($id,4,1); 					//Alarm 4!
			}
		}

		//Alarm 1/2/3/4(!) beenden/quittieren (d.h. Alarm beenden, aber alles sonstige belassen)
		if ($E[9]['value']==1 && $E[9]['refresh']==1) {
			logic_setOutput($id,1,0); 						//Alarm aus
			logic_setOutput($id,2,0);
			logic_setOutput($id,3,0);
			logic_setOutput($id,4,0);
			logic_setOutput($id,13,0); 						//Voralarm! 3 = Aus
			$V[6]=0;
			logic_setVar($id,6,$V[6]);					//Alarm ist aus
			logic_setState($id,0);
		}

		if (logic_getState($id)==1) {

			//Scharfschaltverzögerung
			if ($alarm==0 && getMicrotime()>=logic_getVar($id,4)) {	//V4 wird in setAlarmMode() verändert!
				if ($modus==1) {
					//Alarm 1 = scharf
					logic_setOutput($id,9,1);
					$V[5]=1;
					logic_setVar($id,5,$V[5]);
				} else if ($modus==2) {
					//Alarm 2 = scharf
					logic_setOutput($id,10,1);
					$V[5]=1;
					logic_setVar($id,5,$V[5]);
				} else if ($modus==3) {
					//Alarm 3 = scharf
					logic_setOutput($id,11,1);
					$V[5]=1;
					logic_setVar($id,5,$V[5]);
				}
				logic_setState($id,0);
			}

			//Voralarm
			if ($alarm==1 && $modus==3 && getMicrotime()>=$V[3]) {
				logic_setOutput($id,13,0); 						//Voralarm! 3 = Aus
				logic_setOutput($id,3,1); 						//Alarm 3!
				$V[6]=2;
				logic_setVar($id,6,$V[6]);					//Alarm
				$V[2]=getMicrotime()+($E[12]['value']*60);
				logic_setVar($id,2,$V[2]);					//Alarmtimer
				//logic_setState($id,1,$E[12]['value']*1000*60);
			}

			//Alarmgesamtdauer
			if ($alarm==2 && getMicrotime()>=$V[2]) {
				//Alarm beenden, aber alles scharf belassen
				logic_setOutput($id,1,0); 						//Alarm aus
				logic_setOutput($id,2,0);
				logic_setOutput($id,3,0);
				logic_setOutput($id,13,0); 						//Voralarm! 3 = Aus
				$V[6]=0;
				logic_setVar($id,6,$V[6]);					//Alarm ist aus
				logic_setState($id,0);
			}

		} else {

			//Alarmtrigger?
			if ($modus==1 && $alarm==0 && $V[5]==1) {
				if ($E[1]['value']==1 && $E[1]['refresh']==1) {
					logic_setOutput($id,1,1); 					//Alarm 1!
					$V[6]=2;
					logic_setVar($id,6,$V[6]);				//Alarm
					$V[2]=getMicrotime()+($E[12]['value']*60);
					logic_setVar($id,2,$V[2]);				//Alarmtimer
					logic_setState($id,1,$E[12]['value']*1000*60);
				}
			} else if ($modus==2 && $alarm==0 && $V[5]==1) {
				if ($E[2]['value']==1 && $E[2]['refresh']==1) {
					logic_setOutput($id,2,1); 					//Alarm 2!
					$V[6]=2;
					logic_setVar($id,6,$V[6]);				//Alarm
					$V[2]=getMicrotime()+($E[12]['value']*60);
					logic_setVar($id,2,$V[2]);				//Alarmtimer
					logic_setState($id,1,$E[12]['value']*1000*60);
				}
			} else if ($modus==3 && $alarm==0 && $V[5]==1) {
				if ($E[3]['value']==1 && $E[3]['refresh']==1) {
					logic_setOutput($id,13,1); 					//Voralarm 3!
					$V[6]=1;
					logic_setVar($id,6,$V[6]);				//Voralarm
					$V[3]=getMicrotime()+$E[11]['value'];
					logic_setVar($id,3,$V[3]);				//Voralarmtimer
					logic_setState($id,1,$E[11]['value']*1000);
				}
			}

		}


	}
}

function LB_LBSID_setAlarmMode($id,$E,$alarmId) {
	if ($alarmId==0) {
		//Alarm 1/2/3 deaktivieren
		$modus=0;
		logic_setOutput($id,1,0);	//Alarm! 1 = Aus
		logic_setOutput($id,2,0);	//Alarm! 2 = Aus
		logic_setOutput($id,3,0);	//Alarm! 3 = Aus
		logic_setOutput($id,13,0); 	//Voralarm! 3 = Aus
		logic_setOutput($id,5,0);	//Alarm 1 = Aus
		logic_setOutput($id,6,0);	//Alarm 2 = Aus
		logic_setOutput($id,7,0);	//Alarm 3 = Aus
		logic_setOutput($id,9,0);	//Alarm 1 = unscharf
		logic_setOutput($id,10,0);	//Alarm 2 = unscharf
		logic_setOutput($id,11,0);	//Alarm 3 = unscharf
		logic_setVar($id,5,0);	//Alarm ist unscharf
		logic_setVar($id,6,0);	//Alarm ist aus
		logic_setVar($id,4,0);	//Scharfschalttimer stoppen
		logic_setState($id,0);	//BS stoppen
		logic_setVar($id,1,0);	//modus setzen und returnen
		return 0;
	}

	if ($alarmId==1) {
		//Alarm 1 aktivieren
		logic_setOutput($id,1,0);	//Alarm! 1 = Aus
		logic_setOutput($id,2,0);	//Alarm! 2 = Aus
		logic_setOutput($id,3,0);	//Alarm! 3 = Aus
		logic_setOutput($id,13,0); 	//Voralarm! 3 = Aus
		logic_setOutput($id,5,1);	//Alarm 1 = Ein
		logic_setOutput($id,6,0);	//Alarm 2 = Aus
		logic_setOutput($id,7,0);	//Alarm 3 = Aus
		logic_setOutput($id,9,0);	//Alarm 1 = unscharf (verzögert!)
		logic_setOutput($id,10,0);	//Alarm 2 = unscharf
		logic_setOutput($id,11,0);	//Alarm 3 = unscharf
		logic_setVar($id,5,0);	//Alarm ist noch unscharf
		logic_setVar($id,6,0);	//Alarm ist aus
		logic_setVar($id,4,(getMicrotime()+$E[10]['value']));	//Timer für Scharfschaltverzögerung
		logic_setState($id,1,$E[10]['value']*1000);	//BS auf run (für Scharfschaltung)
		logic_setVar($id,1,1);	//modus setzen und returnen
		return 1;
	}

	if ($alarmId==2) {
		//Alarm 2 aktivieren
		logic_setOutput($id,1,0);	//Alarm! 1 = Aus
		logic_setOutput($id,2,0);	//Alarm! 2 = Aus
		logic_setOutput($id,3,0);	//Alarm! 3 = Aus
		logic_setOutput($id,13,0); 	//Voralarm! 3 = Aus
		logic_setOutput($id,5,0);	//Alarm 1 = Aus
		logic_setOutput($id,6,1);	//Alarm 2 = Ein
		logic_setOutput($id,7,0);	//Alarm 3 = Aus
		logic_setOutput($id,9,0);	//Alarm 1 = unscharf
		logic_setOutput($id,10,0);	//Alarm 2 = unscharf (verzögert!)
		logic_setOutput($id,11,0);	//Alarm 3 = unscharf
		logic_setVar($id,5,0);	//Alarm ist noch unscharf
		logic_setVar($id,6,0);	//Alarm ist aus
		logic_setVar($id,4,(getMicrotime()+$E[10]['value']));	//Timer für Scharfschaltverzögerung
		logic_setState($id,1,$E[10]['value']*1000);	//BS auf run (für Scharfschaltung)
		logic_setVar($id,1,2);	//modus setzen und returnen
		return 2;
	}

	if ($alarmId==3) {
		//Alarm 3 aktivieren
		logic_setOutput($id,1,0);	//Alarm! 1 = Aus
		logic_setOutput($id,2,0);	//Alarm! 2 = Aus
		logic_setOutput($id,3,0);	//Alarm! 3 = Aus
		logic_setOutput($id,13,0); 	//Voralarm! 3 = Aus
		logic_setOutput($id,5,0);	//Alarm 1 = Aus
		logic_setOutput($id,6,0);	//Alarm 2 = Aus
		logic_setOutput($id,7,1);	//Alarm 3 = Ein
		logic_setOutput($id,9,0);	//Alarm 1 = unscharf
		logic_setOutput($id,10,0); 	//Alarm 2 = unscharf
		logic_setOutput($id,11,0);	//Alarm 3 = unscharf (verzögert!)
		logic_setVar($id,5,0);	//Alarm ist noch unscharf
		logic_setVar($id,6,0);	//Alarm ist aus
		logic_setVar($id,4,(getMicrotime()+$E[10]['value']));	//Timer für Scharfschaltverzögerung
		logic_setState($id,1,$E[10]['value']*1000);	//BS auf run (für Scharfschaltung)
		logic_setVar($id,1,3);	//modus setzen und returnen
		return 3;
	}
}
?>
###[/LBS]###


###[EXEC]###
<?

?>
###[/EXEC]###
